/*
 * Copyright (c) 2016, The Linux Foundation. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *    * Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *
 *    * Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials provided
 *      with the distribution.
 *
 *    * Neither the name of The Linux Foundation nor the names of its
 *      contributors may be used to endorse or promote products derived
 *      from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef __ATLAS7_PMU_H__
#define __ATLAS7_PMU_H__

#include <io.h>
#include <soc_timer.h>

#define _PMU_REG_BASE	0x10E30000

#define A7DA_PMU_ANA_PMUCTL1					(_PMU_REG_BASE + 0x20)
#define A7DA_PMU_ANA_PMUCTL2					(_PMU_REG_BASE + 0x24)
#define A7DA_PMU_ANA_AUDIO_REF_CTRL				(_PMU_REG_BASE + 0x38)
#define A7DA_PMU_AUDIO_REF_CTRL2				(_PMU_REG_BASE + 0x3C)
#define A7DA_PMU_AUDIO_REGS_I2S_CTRL			(_PMU_REG_BASE + 0x40)
#define A7DA_PMU_AUDIO_REGS_CLK_CTRL			(_PMU_REG_BASE + 0x44)
#define A7DA_PMU_AUDIO_KCODEC_CTRL				(_PMU_REG_BASE + 0x48)
#define A7DA_PMU_AUDIO_DIGMIC_CTRL				(_PMU_REG_BASE + 0x50)
#define A7DA_PMU_AUDIO_DAC_CTRL					(_PMU_REG_BASE + 0x54)
#define A7DA_PMU_AUDIO_CTRL_SPARE_0				(_PMU_REG_BASE + 0x58)
#define A7DA_PMU_AUDIO_ANA_DAC_CTRL0			(_PMU_REG_BASE + 0x60)
#define A7DA_PMU_AUDIO_ANA_REF_CTRL0			(_PMU_REG_BASE + 0x64)
#define A7DA_PMU_AUDIO_ANA_ADC_CTRL0			(_PMU_REG_BASE + 0x68)
#define A7DA_PMU_AUDIO_ANA_ADC_CTRL1			(_PMU_REG_BASE + 0x6C)
#define A7DA_PMU_AUDIO_ANA_ADC_CTRL2			(_PMU_REG_BASE + 0x70)
#define A7DA_PMU_AUDIO_ANA_ADC_CTRL3			(_PMU_REG_BASE + 0x74)
#define A7DA_PMU_AUDIO_ANA_ADC_CTRL4			(_PMU_REG_BASE + 0x78)
#define A7DA_PMU_AUDIO_ANA_CAL_CTRL0			(_PMU_REG_BASE + 0x7C)
#define A7DA_PMU_KCODEC_ADC_A_GAIN				(_PMU_REG_BASE + 0xA0)
#define A7DA_PMU_KCODEC_ADC_A_SAMP_RATE			(_PMU_REG_BASE + 0xAC)
#define A7DA_PMU_KCODEC_ADC_B_GAIN				(_PMU_REG_BASE + 0xBC)
#define A7DA_PMU_KCODEC_ADC_B_SAMP_RATE			(_PMU_REG_BASE + 0xCC)
#define A7DA_PMU_KCODEC_CONFIG_EXTENSION2		(_PMU_REG_BASE + 0xF8)
#define A7DA_PMU_KCODEC_CONFIG2_EXTENSION2		(_PMU_REG_BASE + 0x110)
#define A7DA_PMU_KCODEC_CONFIG					(_PMU_REG_BASE + 0x150)
#define A7DA_PMU_KCODEC_CONFIG2					(_PMU_REG_BASE + 0x158)
#define A7DA_PMU_KCODEC_DAC_A_GAIN				(_PMU_REG_BASE + 0x164)
#define A7DA_PMU_KCODEC_DAC_A_SAMP_RATE			(_PMU_REG_BASE + 0x16C)
#define A7DA_PMU_KCODEC_DAC_B_GAIN				(_PMU_REG_BASE + 0x174)
#define A7DA_PMU_KCODEC_DAC_B_SAMP_RATE			(_PMU_REG_BASE + 0x17C)
#define A7DA_PMU_KCODEC_DAC_C_GAIN				(_PMU_REG_BASE + 0x184)
#define A7DA_PMU_KCODEC_DAC_C_SAMP_RATE			(_PMU_REG_BASE + 0x188)
#define A7DA_PMU_KCODEC_DAC_D_GAIN				(_PMU_REG_BASE + 0x190)
#define A7DA_PMU_KCODEC_DAC_D_SAMP_RATE			(_PMU_REG_BASE + 0x194)
#define A7DA_PMU_KCODEC_DAC_A_DC_OFFSET			(_PMU_REG_BASE + 0x1E8)
#define A7DA_PMU_KCODEC_DAC_B_DC_OFFSET			(_PMU_REG_BASE + 0x1EC)
#define A7DA_PMU_KCODEC_DAC_C_DC_OFFSET			(_PMU_REG_BASE + 0x1F0)
#define A7DA_PMU_KCODEC_DAC_D_DC_OFFSET			(_PMU_REG_BASE + 0x1F4)
#define A7DA_PMU_AUDIO_PLL_CTRL_1				(_PMU_REG_BASE + 0x230)
#define A7DA_PMU_AUDIO_PLL_STATUS				(_PMU_REG_BASE + 0x250)
#define A7DA_PMU_KCODEC_WARP_UPDATE				(_PMU_REG_BASE + 0x368)

#define ANA_MACRO_CLK_TEST_SEL_MASK				(0x3 << 5)
#define ANA_MACRO_CLK_TEST_SEL_SHIFT			5

#define ANA_DIG_MIC_CLK_TEST_EN_MASK			1
#define ANA_DIG_MIC_CLK_TEST_EN_SHIFT			0

#define PMUCTRL2_VBG_TRIM						0xF
#define PMUCTRL2_IREF_TRIM						(0x7 << 4)

#define AUDIO_ANA_REF_AUDBIAS_IREF_EN			1
#define AUDIO_ANA_REF_AUDBIAS_IREF_TRIM_SHIFT	1
#define AUDIO_ANA_REF_AUDBIAS_VAG_RX_EN			(1 << 4)
#define AUDIO_ANA_REF_AUDBIAS_VAG_TX_EN			(1 << 5)
#define AUDIO_ANA_REF_VGA_IREF_TX_EN			(1 << 8)
#define AUDIO_ANA_REF_AUDBIAS_IREF_TRIM_MASK	(0x7 << 1)

#define AUDIO_REF_BIAS_BG_VTH_TRIM_MASK			0xF
#define AUDIO_REF_BIAS_BG_PTAT_TRIM_MASK		(0xF << 4)
#define AUDIO_REF_BIAS_BG_PTAT_TRIM_SHIFT		4
#define AUDIO_REF_BIAS_BG_VTH_SHIFT				0

#define AUDIO_REF_BOOST_EN_DACBUFF_IREF_MASK	0x3

#define DAC_CLK_EN								(0xF << 6)

#define DAC_RESET_MASK							0xF

#define KCODEC_DAC_EN							1
#define KCODEC2_CONFIG_DAC_A_EN					(1 << 12)
#define KCODEC2_CONFIG_DAC_B_EN					(1 << 13)
#define KCODEC2_CONFIG_DAC_C_EN					(1 << 12)
#define KCODEC2_CONFIG_DAC_D_EN					(1 << 13)

#define AUDIO_ANA_DAC_VGEN_EN_MASK				1
#define AUDIO_ANA_DAC_VGEN_EN_SHIFT				0
#define AUDIO_ANA_DAC_LOUT_EN_MASK				(0xF << 1)
#define AUDIO_ANA_DAC_LOUT_EN_SHIFT				1
#define AUDIO_ANA_DAC_BUF_LOUT_EN_MASK			(0xF << 7)
#define AUDIO_ANA_DAC_BUF_LOUT_EN_SHIFT			7

#define KCODEC_DAC_GAIN_SELECT_FINE				(1 << 15)
#define KCODEC_ADC_GAIN_SELECT_FINE				(1 << 15)

#define KCODEC_CONFIG_DSM_DITHER_EN_MASK		(1 << 7)
#define KCODEC_CONFIG_DSM_DITHER_EN_SHIFT		7

#define KCODEC_CONFIG_DEM_DITHER_CFG_MASK		0x1F
#define KCODEC_CONFIG_DEM_DITHER_CFG_SHIFT		0

#define KCODEC_DAC_X_DC_OFFSET_MASK				0xFF
#define KCODEC_DAC_X_DC_OFFSET_SHIFT			0

/* fields of register KCODEC_CONFIG */
#define KCODEC_ADC_EN							(1 << 1)
#define KCODEC2_CONFIG_ADC_A_EN					(1<<10)
#define KCODEC2_CONFIG_ADC_B_EN					(1<<11)

/* fields of register AUDIO_ANA_REF_CTRL0 */
#define AUDIO_ANA_REF_AUDBIAS_IREF_EN			1
#define AUDIO_ANA_REF_AUDBIAS_IREF_TRIM			(7<<1)
#define AUDIO_ANA_REF_AUDBIAS_VAG_TSADC_EN		(1<<6)
#define AUDIO_ANA_REF_MICBIAS_EN				(1<<7)

/*fields of register AUDIO_REGS_CLK_CTRL */
#define ADC_CLK_EN								(0xF<<2)
#define AUDIO_ANA_CAL_ADC_EN					1
#define AUDIO_ANA_CAL_CLK_EN					(1<<11)

/*fields of register AUDIO_ANA_ADC_CTRL1 */
#define AUDIO_ANA_ADC_CH12_CCAL_SEL_MASK		(0xf<<8)
#define AUDIO_ANA_ADC_CH12_CCAL_SEL_SHIFT		8

#define AUDIO_ANA_ADC_CHANNEL_EN				1
#define AUDIO_ANA_ADC_CHANNEL_DITHER_EN			(1<<1)
#define AUDIO_ANA_ADC_CHANNEL_DWA_EN			(1<<2)
#define AUDIO_ANA_ADC_CHANNEL_GAIN_SEL			(0xf<<3)

/*fields of register AUDIO_ANA_CAL_CTRL0 */
#define AUDIO_ANA_CAL_ADC_EN					1

#define DAC_BASE_SMAPLE_RATE_44K1				0
#define DAC_BASE_SMAPLE_RATE_48K0				1
#define DAC_BASE_SMAPLE_RATE_32K0				2
#define DAC_BASE_SMAPLE_RATE_40K0				3
#define DAC_BASE_SMAPLE_RATE_96K0				4
#define DAC_BASE_SMAPLE_RATE_192K0				5

#define KCODEC_DAC_SELECT_EXT					(1 << 5)
#define KCODEC_DAC_EXT_BASE_SAMP_RATE_SHIFT		6
#define KCODEC_DAC_EXTENDED_BASE_SAMP_RATE_MASK	(0xF << 6)

#define ADC_SAMPLE_RATE_08K						0
#define ADC_SAMPLE_RATE_11K						1
#define ADC_SAMPLE_RATE_12K						10
#define ADC_SAMPLE_RATE_16K						2
#define ADC_SAMPLE_RATE_22K						3
#define ADC_SAMPLE_RATE_24K						4
#define ADC_SAMPLE_RATE_32K						5
#define ADC_SAMPLE_RATE_44K						6
#define ADC_SAMPLE_RATE_48K						8
#define ADC_SAMPLE_RATE_96K						9

#define KCODEC_CONFIG_DEM_DITHER_CFG_MASK		0x1F
#define KCODEC_CONFIG_DEM_DITHER_CFG_SHIFT		0

#define TXADC_IREF_EN							1

#define AUDIO_ANA_CTRL_ADC_EN					1

#define AUDIO_ANA_ADC_CHANNEL_CLK_SEL_DELAY_MASK	(0xF << 7)
#define AUDIO_ANA_ADC_CHANNEL_CLK_SEL_DELAY_SHIFT	7
#define AUDIO_GAIN_MASK					0x1FF

#define AUDIO_ANA_ADC_CHANNEL_GAIN_SEL_MASK		(0xf << 3)
#define AUDIO_ANA_ADC_CHANNEL_GAIN_SEL_SHIFT	3
#define AUDIO_ANA_ADC_MICAMP_GAIN_SEL_MASK		(0xf << 3)
#define AUDIO_ANA_ADC_MICAMP_GAIN				(10 << 3)

#define PMUCTRL2_VBG_TRIM_MASK					0xF

/* Enable LD01 1.8V and LDO2 2.5V for PMU audio module */
static inline void pmu_audio_regulator_enable(void)
{
	SOC_REG(A7DA_PMU_ANA_PMUCTL1) |= (BIT(1) | BIT(4) | (2 << 2) | (2 << 5));
}

static inline void pmu_enable_dac(void)
{
	SOC_REG(A7DA_PMU_AUDIO_KCODEC_CTRL) |= (BIT(0));
}

/* PMU audio clock registers */
static inline void pmu_clk_enable(void)
{
	SOC_REG(A7DA_PMU_AUDIO_PLL_CTRL_1) &= ~(BIT(11));
	vUsWait(10);
	SOC_REG(A7DA_PMU_AUDIO_PLL_CTRL_1) |= BIT(12);
}

#endif /*__ATLAS7_PMU_H__*/
